Subject: bug#62720: 29.0.60; Not easy at all to upgrade :core packages like Eglot

From: Dmitry Gutov <[email-masked]>
Date: Sat, 22 Apr 2023 13:30:41 +0300

On 22/04/2023 11:33, Eli Zaretskii wrote:
>> Date: Sat, 22 Apr 2023 03:57:03 +0300
>> From: Dmitry Gutov<[email-masked]>
>> Cc:[email-masked],[email-masked],[email-masked],
>>   [email-masked],[email-masked],[email-masked]
>>
>>> That's what I imagined: adding a new optional argument to
>>> package--updateable-packages which would include builtins in the result.
>>>
>>> And only pass it when called from package-upgrade.
>>>
>>> Hopefully that's the kind of optional that you meant.
>> Here's a patch which does that. The diff could be reduced (the
>> package-update part) by binding the new option
>> (package-install-upgrade-built-in), but I figured it's better to avoid
>> interdependency while we're still deciding what to keep.
> Thanks, but this is not what was being discussed, AFAIU.  What I said
> I'd agree to is to have package-update accept a prefix argument and
> heed package-install-upgrade-built-in (perhaps renamed),

I think I explained in the previous email why reusing 
package-install-upgrade-built-in doesn't seem like a good idea.

> and only then
> update built-in packages.

I asked what plausible scenario you think might be broken by having 
package-update upgrade builtin package by default.

Do you want to answer that?

> I also don't think I like the significant changes in package-update,
> nor understand why they are needed.

Like I said: the changes are to avoid relying on package-install being 
able to install a package that's already installed. Which currently 
works only for builtins and when only a user option is set. It's a mess.

And to "avoid interdependency".

Just to be clear, we are talking about the 4 lines at the end, right?